VERSION 5.00
Begin VB.Form frmCharPicker 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Character Selector"
   ClientHeight    =   5175
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   4575
   LinkTopic       =   "Form2"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   345
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   305
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picStatus 
      Align           =   2  'Align Bottom
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   600
      Left            =   0
      ScaleHeight     =   540
      ScaleWidth      =   4515
      TabIndex        =   1
      Top             =   4575
      Width           =   4575
   End
   Begin VB.PictureBox picSelect 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   4575
      Left            =   0
      ScaleHeight     =   305
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   305
      TabIndex        =   0
      Top             =   0
      Width           =   4575
   End
End
Attribute VB_Name = "frmCharPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private CurX As Byte, CurY As Byte
Private SelX As Byte, SelY As Byte
Public Sub DrawChar(ByVal CharVal As Byte)

  'depends on scale?
  Dim i As Long, j As Long
  Dim X As Long, Y As Long
  Dim Me_hDC As Long, lngColor As Long
  Dim lngVal1 As Long, lngVal2 As Long
  
  On Error GoTo ErrHandler
  
  Me_hDC = picSelect.hdc
  
  Select Case CharWidth
  Case 4
    X = (CharVal Mod 16) * 19 + 8
    Y = (CharVal \ 16) * 19 + 6
    
    For j = 0 To 7
      lngVal1 = CharData(CharVal, j) \ 16
      
      For i = 3 To 0 Step -1
        'extract bits from the data for this row
        lngColor = ((lngVal1 And 1) - 1) And &HFFFFFF
        SetPixelV Me_hDC, X + i, Y + j, lngColor
        
        lngVal1 = lngVal1 \ 2
     Next i
    Next j
  Case 8
    X = (CharVal Mod 16) * 19 + 6
    Y = (CharVal \ 16) * 19 + 6
    
    For j = 0 To 7
      lngVal1 = CharData(CharVal, j)
      
      For i = 7 To 0 Step -1
        'extract bits from the data for this row
        lngColor = ((lngVal1 And 1) - 1) And &HFFFFFF
        SetPixelV Me_hDC, X + i, Y + j, lngColor
        
        lngVal1 = lngVal1 \ 2
     Next i
    Next j
  Case 16
    X = (CharVal Mod 16) * 19 + 2
    Y = (CharVal \ 16) * 19 + 2
    
    For j = 0 To 15
      lngVal1 = CharData(CharVal, j * 2)
      lngVal2 = CharData(CharVal, j * 2 + 1)
      
      For i = 7 To 0 Step -1
        'extract all sixteen bits from the data for this row
        lngColor = ((lngVal1 And 1) - 1) And &HFFFFFF
        SetPixelV Me_hDC, X + i, Y + j, lngColor
        
        lngColor = ((lngVal2 And 1) - 1) And &HFFFFFF
        SetPixelV Me_hDC, X + 8 + i, Y + j, lngColor
        
        lngVal1 = lngVal1 \ 2
        lngVal2 = lngVal2 \ 2
     Next i
    Next j
  End Select
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub


Public Sub DrawCharsOnGrid()

  'redraw entire charselect grid
  
  Dim i As Long, j As Long
  picSelect.Cls
  
  For i = 0 To 16
    picSelect.Line (i * 19, 0)-(i * 19, 304), &HC0C0C0
    picSelect.Line (0, i * 19)-(304, i * 19), &HC0C0C0
  Next i
  
  For j = 0 To 15
    For i = 0 To 15
      'if this character is in use, draw it
      If CharUsed(j * 16 + i) Then
        DrawChar j * 16 + i
      Else
        'x it out
        picSelect.Line (i * 19 + 2, j * 19 + 2)-Step(16, 16), vbRed
        picSelect.Line (i * 19 + 2, j * 19 + 17)-Step(16, -16), vbRed
      End If
    Next i
  Next j
End Sub

Public Sub SelectChar(ByVal OldX As Byte, ByVal OldY As Byte)

  'first, unselect current char
  picSelect.Line (SelX * 19 + 1, SelY * 19 + 1)-Step(17, 17), vbWhite, B
  
  'set new selected x, y
  SelX = OldX
  SelY = OldY
  picSelect.Line (SelX * 19 + 1, SelY * 19 + 1)-Step(17, 17), &H808080, B
End Sub

Public Sub SetPixel(ByVal SelChar As Byte, ByVal SelX As Byte, ByVal SelY As Byte, ByVal pColor As Long)

  'depends on scale?
  Dim i As Long, j As Long
  Dim X As Long, Y As Long
  Dim Me_hDC As Long, lngColor As Long
  Dim lngVal1 As Long, lngVal2 As Long
  
  On Error GoTo ErrHandler
  
  Select Case CharWidth
  Case 4
    X = (SelChar Mod 16) * 19 + 8
    Y = (SelChar \ 16) * 19 + 6
    SetPixelV picSelect.hdc, X + SelX, Y + SelY, pColor
  Case 8
    X = (SelChar Mod 16) * 19 + 6
    Y = (SelChar \ 16) * 19 + 6
    SetPixelV picSelect.hdc, X + SelX, Y + SelY, pColor
  Case 16
    X = (SelChar Mod 16) * 19 + 2
    Y = (SelChar \ 16) * 19 + 2
    SetPixelV picSelect.hdc, X + SelX, Y + SelY, pColor
        
  End Select
  
  picSelect.Refresh
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
  
End Sub


Private Sub UpdateStatusBar()

  On Error GoTo ErrHandler
  
  picStatus.Cls
  picStatus.Print " Character Code: 0x" & Hex2(CurY * 16 + CurX), Chr$(CurY * 16 + CurX)
  picStatus.Print " " & strCharText(CurY * 16 + CurX)
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub Form_Activate()

  'set flag so window position gets maintained
  PickerPos = True
End Sub

Private Sub Form_Load()

  'always draw chars on grid
  DrawCharsOnGrid
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  'always save position
  PickerTop = frmCharPicker.Top
  PickerLeft = frmCharPicker.Left
  
  'always ensure toggle is set correctly
  frmMain.cmdCharList.Caption = "&Show Character Picker"

End Sub


Private Sub picSelect_DblClick()

  'dont select char 0
  If CurX = 0 And CurY = 0 Then
    Exit Sub
  End If
  
  'select a char
  frmMain.EditChar CurY * 16 + CurX
  frmMain.SetFocus
End Sub

Private Sub picSelect_KeyDown(KeyCode As Integer, Shift As Integer)

  Select Case Shift
  Case 0
    Select Case KeyCode
    Case vbKeyUp
      If SelY = 0 Then
        Exit Sub
      End If
      'check to make sure we dont
      'end up on char 0
      If CurX = 0 And CurY = 1 Then
        Exit Sub
      End If
      CurY = SelY - 1
      CurX = SelX
      
    Case vbKeyDown
      If SelY = 13 Then
        Exit Sub
      End If
      CurY = SelY + 1
      CurX = SelX
      
    Case vbKeyRight
      If SelX = 15 Then
        Exit Sub
      End If
      CurX = SelX + 1
      CurY = SelY
      
    Case vbKeyLeft
      If SelX = 0 Then
        Exit Sub
      End If
      'check to make sure we
      'dont end up on char 0
      If CurY = 0 And CurX = 1 Then
        Exit Sub
      End If
      CurX = CurX - 1
      CurY = SelY
      
    Case Else
      Exit Sub
    End Select
    
    SelectChar CurX, CurY
    
    'update status
    UpdateStatusBar

  End Select
End Sub

Private Sub picSelect_KeyPress(KeyAscii As Integer)

  If KeyAscii = 13 Then
    'same as dbl click, but with selection, not current
    frmMain.EditChar SelY * 16 + SelX
    frmMain.SetFocus
  End If
  
  
End Sub

Private Sub picSelect_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

  
  CurX = X \ 19
  CurY = Y \ 19
  'sometimes if cursor is positioned just right,
  'values will be set to 16, which causes error
  If CurX > 15 Then CurX = 15
  If CurY > 15 Then CurY = 15
  
  'update status
  UpdateStatusBar
End Sub

Private Sub picSelect_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'ignore mouse down events
  If Button <> 0 Then
    Exit Sub
  End If
  
  'set cursor to nodrop if on char 0
  If X \ 19 = 0 And Y \ 19 = 0 Then
    Me.MousePointer = vbNoDrop
  Else
    Me.MousePointer = vbDefault
  End If
  
  'set current pos based on mouse location
  CurX = X \ 19
  CurY = Y \ 19
  If CurX < 0 Then CurX = 0
  If CurX > 15 Then CurX = 15
  If CurY < 0 Then CurY = 0
  If CurY > 15 Then CurY = 15
  


  'update status
  UpdateStatusBar
End Sub

Private Sub picSelect_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

  'dont select char 0
  If CurX = 0 And CurY = 0 Then
    Exit Sub
  End If
  
  SelectChar CurX, CurY
End Sub


